Loading...
Searching...
No Matches
Qore::PipeOutputStream Class Reference

This class is not intended to be instantiated directly, please see StreamPipe. More...

`#include <QC_PipeOutputStream.dox.h>`

Inheritance diagram for Qore::PipeOutputStream:
[legend]

## Public Member Functions

nothing | close ()
| Closes the output stream and releases any resources.
nothing | reportError (hash ex)
| Causes all operations on both pipe streams to wake up and throw an exception.
nothing | write (binary data)
| Writes bytes to the output stream.
Public Member Functions inherited from Qore::OutputStream
abstract nothing | close ()
| Flushes any buffered (unwritten) bytes, closes the output stream and releases all resources.
| constructor ()
| Constructor.
abstract nothing | write (binary data)
| Writes bytes to the output stream.
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses.
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation.
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation.

## Protected Member Functions

| constructor ()
| Creates the PipeOutputStream.

## Detailed Description

This class is not intended to be instantiated directly, please see StreamPipe.

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  - StreamWriter for a class that can be used to write various kinds of data to an OutputStream
  - Qore::StreamPipe

Since
  Qore 0.8.13

## Member Function Documentation

## close()

nothing Qore::PipeOutputStream::close | ( |  | ) |

Closes the output stream and releases any resources.

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

## reportError()

nothing Qore::PipeOutputStream::reportError | ( | hash | ex | ) |

Causes all operations on both pipe streams to wake up and throw an exception.

Normally used from the background thread to report an error to the main thread.

Parameters

  ex | the exception, must contain strings 'err' and 'desc'

## write()

nothing Qore::PipeOutputStream::write | ( | binary | data | ) |

Writes bytes to the output stream.

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object